#include "INtimeTest.h"

// ̃e[u
uint16_t	g_Ax_t[5] = { SGL_AXIS_X , SGL_AXIS_Y , SGL_AXIS_Z , SGL_AXIS_U , SGL_AXIS_X | SGL_AXIS_Y | SGL_AXIS_Z | SGL_AXIS_U };
uint8_t		ax_num = 0;		// ̃e[u̔ԍ
uint16_t	cmd = 0;		// R}hԍ	
uint16_t	MoveAxis = 0;	// 삳w莲(1ʒu)
int32_t		Dist = 0;		// ʒu(1ʒu)
uint16_t	msts[4] = { 0 };	// eCXe[^Xi[
uint16_t	ssts[4] = { 0 };	// eTuXe[^Xi[

BOOL		quit_f = FALSE; // [VXbhItO
uint16_t	apiBusyCnt = 0;	// APIBusẙmF

uint16_t	motionSeq = MOTION_SEQ_NONE; // [VV[PX
uint8_t		subSeq = 0;			// TuV[PXԍ
uint8_t		initSubSeq = 0;		// TuV[PXԍ
BOOL		init_f = FALSE;		// tO

// ~ʕԂ̍W(X, Y)
int32_t		cir_coordinate[2][2] = { { 10000, 10000 },
									 { 0, 10000 } };

// L[{[h̃R}hEp[^ǂݍ
void getCommand()
{
	int count = 0;

	while (count < SEMAPHORE_REACQ_TIME) 
	{
		if(WaitForRtSemaphore(gInit.hExclSem, 1, NO_WAIT))
		{
			count++;
		}
		else {
			if (g_setCmd != app_cmd_none) {
				cmd = g_setCmd;
				g_setCmd = app_cmd_none; // R}hNA
			}
			MoveAxis = g_MoveAxis;
			Dist = g_Dist;
			ReleaseRtSemaphore(gInit.hExclSem, 1);
			break;
		}
	}
}

// R}hNA
void ClrCommand()
{
	cmd = app_cmd_none;
}

// Xe[^X擾
void readStatus()
{
	uint32_t ret;

	for (int ax = 0; ax < 4; ax++)
	{
		g_SlvRef.axis = g_Ax_t[ax];
		// ẽCXe[^X擾
		ret = hic400_ReadMainSts(&g_SlvRef, &msts[ax]);
		if (ret != 0) {
			printf("hic400_ReadMainSts failed. %s Error : 0x%x\n", g_AxName_t[ax], ret);
		}
		// ẽTuXe[^X擾
		ret = hic400_ReadSubSts(&g_SlvRef, &ssts[ax]);
		if (ret != 0) {
			printf("hic400_ReadSubSts failed. %s Error : 0x%x\n", g_AxName_t[ax], ret);
		}
	}
	return;
}

// S~Ă邩mF
void checkStatus()
{	
	for (int ax = 0; ax < 4; ax++)
	{
		if ((msts[ax] & MAIN_STS_SEND) != MAIN_STS_SEND) { // Xe[^X`FbN
			return;
		}
	}
	motionSeq = MOTION_SEQ_DONE;	// 슮
}

// Xe[^XEV[PXԂ̍XV
void UpdateStatus()
{
	int count = 0;

	while (count < SEMAPHORE_REACQ_TIME)
	{
		if (WaitForRtSemaphore(gInit.hExclSem, 1, NO_WAIT))
		{
			count++;
		}
		else {
			g_MotionSeq = motionSeq; // [VV[PXXV
			for (int ax = 0; ax < 4; ax++) { // Xe[^XXV
				g_MainSts[ax] = msts[ax];
				g_SubSts[ax] = ssts[ax];
			}
			ReleaseRtSemaphore(gInit.hExclSem, 1);
			break;
		}
	}
}

// G[(API̖߂lG[)
void setError()
{
	motionSeq = MOTION_SEQ_ERROR; // G[
	quit_f = TRUE;				  // I
}

// ݒF|[gݒ
void initPortC400()
{
	uint32_t ret;
	uint8_t port = 0;
	uint16_t data = 0;

	switch (initSubSeq)
	{
	case INIT_SEQ_PORT_0:
		/* ELSɐؑ(B) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = ELL_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_1:
		/* ELS gp/sgpؑ(gp) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = ELL_USE_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_2:
		/* ͐ؑ(DLS) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = DLS_PCS_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_3:
		/* X^[g/Xgbvݒ(gp) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = STA_STP_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_4:
		/* Rp[^o͐ݒ(RENV4ݒCMP3ô͖ߏo͖) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = CMP_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_5:
		/* JOGX^[gݒ(DRIĂȂ̂Őݒ薳) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = DLS_DR_PORT;
		data = 0x00;
		break;
	case INIT_SEQ_PORT_6:
		/* DLS/EMG͐ؑ(EMG) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		port = DLS_EMG_PORT;
		data = 0x00;
		break;
	}
	// |[gݎs
	ret = hic400_wPortW(&g_SlvRef, port, data);
	if (ret != 0) {
		printf("hic400_wPortW failed.\n");
		subSeq = INIT_SEQ_ERROR;
	}
	// API Xe[g`FbN
	if (g_SlvRef.status == API_STA_DONE) // Done
	{
		apiBusyCnt = 0;
		ax_num++; // ̎
		if (ax_num == 4) // Ss
		{
			initSubSeq++; // ̐ݒ
			ax_num = 0;
		}
	}
	else if (g_SlvRef.status == API_STA_BUSY) // Busy
	{
		apiBusyCnt++; // BusyJEg
		if (apiBusyCnt > BUSY_MAX_COUNT) {// JEgI[o[
			printf("hic400_wPortW BusyJEgI[o[\n");
			subSeq = INIT_SEQ_ERROR;
		}
	}

	// |[gݒ肪SďImF
	if (initSubSeq == INIT_SEQ_PORT_END) {
		initSubSeq = 0;
		subSeq++; // ̏V[PX
	}
	return;
}

// ݒFWX^
void	initRegC400()
{
	uint32_t ret;
	uint16_t cmd = 0;
	uint32_t value = 0;

	switch (initSubSeq)
	{
	case INIT_SEQ_REG_0:
		/* WX^(x[XxWX^:PRFL = 200) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x81;
		value = 200;
		break;
	case INIT_SEQ_REG_1:
		/* WX^(쑬xWX^:PRFH = 2000) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x82;
		value = 2000;
		break;
	case INIT_SEQ_REG_2:
		/* WX^([gWX^) */
		/* ([U[Y}jA^p҂̉Ԃ̌vZQ) */
		/* NbNg = 19,660,800Hz,  =  = 0.5bƂƂA */
		/* PRFH = 2000APRFL = 200ƏLŐݒ肵̂ŁAPRUR([g)́A */
		/* (b) = (PRFH - PRFL) * (PRUR + 1) * 4 / 19660800 */
		/* PRUR = 1364 */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x83;
		value = 1364;
		break;
	case INIT_SEQ_REG_3:
		/* WX^({ = 1{APRMG = 299) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x85;
		value = 299;
		break;
	case INIT_SEQ_REG_4:
		/* WX^(샂[hFPRMD = 0x8008000) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x87;
		value = 0x8008000;
		break;
	case INIT_SEQ_REG_5:
		/* WX^(ړʕ␳xFRFA = 200) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x9b;
		value = 200;
		break;
	case INIT_SEQ_REG_6:
		/* WX^(ݒ1FRENV1 = 0x20434004) */
		/* wߏóFʃpXw߂̐_ */
		/* OLSEDLSESVALMBځAINPOSAڂɂB */
		/* ELSSVALM͓͎~ADLSo͓삪݂̂Ńb`ȂB */
		/* T[{G[A_AɃJE^NAo͂ȂB */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x9c;
		value = 0x20434004;
		break;
	case INIT_SEQ_REG_7:
		/* 	ėpo͐ݒ蓙 */
		/* WX^(ݒ2FRENV2 = 0x0020fd55) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x9d;
		value = 0x0020fd55;
		break;
	case INIT_SEQ_REG_8:
		/* WX^(ݒ3FRENV3 = 0x00f00002) */
		/* _AFZT{GR[__A(OLS+Z) */
		/* CLROFFONB_AJE^NA */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0x9e;
		value = 0x00f00002;
		break;
	case INIT_SEQ_REG_9:
		/* WX^(CxgINTݒFRIRQ = 1(~) */
		g_SlvRef.axis = g_Ax_t[ax_num];
		cmd = 0xac;
		value = 1;
		break;
	}
	// WX^ݎs
	ret = hic400_wReg(&g_SlvRef, cmd, value);
	if (ret != 0) {
		printf("hic400_wReg failed.\n");
		subSeq = INIT_SEQ_ERROR;
	}
	// API Xe[g`FbN
	if (g_SlvRef.status == API_STA_DONE) // Done
	{
		apiBusyCnt = 0;
		ax_num++; // ̎
		if (ax_num == 4) // Ss
		{
			initSubSeq++; // ̐ݒ
			ax_num = 0;
		}
	}
	else if (g_SlvRef.status == API_STA_BUSY) // Busy
	{
		apiBusyCnt++; // BusyJEg
		if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[
			printf("hic400_wReg BusyJEgI[o[\n");
			subSeq = INIT_SEQ_ERROR;
		}
	}

	// WX^ݒ肪SďImF
	if (initSubSeq == INIT_SEQ_REG_END){
		initSubSeq = 0;
		subSeq++; // ̏V[PX
	}
	return;
}

// ݒF쏀
void	readyToC400()
{
	uint32_t ret;
	uint16_t cmd = 0;

	// SΏ
	g_SlvRef.axis = g_Ax_t[4];

	switch (initSubSeq)
	{
	case INIT_SEQ_RDY_0:
		/* SVOFF */
		cmd = 0x10;
		break;
	case INIT_SEQ_RDY_1:
		/* SVRST OFF */
		cmd = 0x11;
		break;
	case INIT_SEQ_RDY_2:
		/* SVON */
		cmd = 0x18;
		break;
	}
	// R}h
	ret = hic400_wCmdW(&g_SlvRef, cmd);
	if (ret != 0) {
		printf("hic400_wCmdW failed.\n");
		subSeq = INIT_SEQ_ERROR;
	}
	// API Xe[g`FbN
	if (g_SlvRef.status == API_STA_DONE)
	{
		apiBusyCnt = 0;
		if (initSubSeq == INIT_SEQ_RDY_1) // SVRST OFFɃTuXe[^XmF
		{
			// STuXe[^X0ɂȂĂ邩mF
			for (int ax = 0; ax < 4; ax++)
			{
				if (ssts[ax] != 0x00) { // `FbN
					printf("SVRST OFF failed. %s Error : 0x%x\n", g_AxName_t[ax], ssts[ax]);
					subSeq = INIT_SEQ_ERROR;
					return;
				}
			}
		}
		else if (initSubSeq == INIT_SEQ_RDY_2) // SVONɃTuXe[^XmF
		{
			// SSVONĂ邩mF
			for (int ax = 0; ax < 4; ax++)
			{
				if (ssts[ax] != 0x01) { // Xe[^X`FbN
					printf("SVON failed. %s Error : 0x%x\n", g_AxName_t[ax], ssts[ax]);
					subSeq = INIT_SEQ_ERROR;
					return;
				}
			}			
		}
		initSubSeq++; // ̐ݒ
	}
	else if (g_SlvRef.status == API_STA_BUSY) // Busy
	{
		apiBusyCnt++; // BusyJEg
		if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
			printf("hic400_wCmdW BusyJEgI[o[\n");
			subSeq = INIT_SEQ_ERROR;
		}
	}

	// 쏀ݒ肪SďImF
	if (initSubSeq == INIT_SEQ_RDY_END) {
		subSeq = 0;
		initSubSeq = 0;
		motionSeq = MOTION_SEQ_DONE; // 烂[VV[PXu슮vԂɂ
		init_f = TRUE;
	}
	return;
}

// 1wʒu
void motion_Move()
{
	uint32_t ret;

	switch (subSeq)
	{
	case MOVE_SEQ_POS:	// ڕWʒu̐ݒ
		g_SlvRef.axis = g_Ax_t[MoveAxis];
		ret = hic400_WritPos(&g_SlvRef, Dist);
		if (ret != 0) {
			printf("hic400_WritPos failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_POS))
		{
			apiBusyCnt = 0;
			subSeq++; // ̐ݒ
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritPos BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case MOVE_SEQ_MODE:	// 샂[huʒu߁v̐ݒ
		g_SlvRef.axis = g_Ax_t[MoveAxis];
		ret = hic400_WritOpeMode(&g_SlvRef, 0x41);
		if (ret != 0) {
			printf("hic400_WritOpeMode failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_OPE_MODE))
		{
			apiBusyCnt = 0;
			subSeq++; // ̐ݒ
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritOpeMode BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case MOVE_SEQ_START:	// X^[g
		g_SlvRef.axis = g_Ax_t[MoveAxis];
		ret = hic400_AccStart(&g_SlvRef);
		if (ret != 0) {
			printf("hic400_AccStart failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == ACC_START))
		{
			subSeq = 0;
			apiBusyCnt = 0;
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_AccStart BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	}
	return;
}

// 2~ʕ
void motion_Circle()
{
	uint32_t ret;

	switch (subSeq)
	{
	case CIR_SEQ_POS_DIST:	// I_ʒu̐ݒ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_WritPos(&g_SlvRef, cir_coordinate[0][ax_num]);
		if (ret != 0) {
			printf("hic400_WritOpeMode failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_POS))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 2) // X, Ys
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritPos BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case CIR_SEQ_POS_CENTER:	// Sʒu̐ݒ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_wReg(&g_SlvRef, 0x88, cir_coordinate[1][ax_num]);
		if (ret != 0) {
			printf("hic400_wReg failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == W_REG))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 2) // X, Ys
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_wReg BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case CIR_SEQ_MODE:	// 샂[hu~ʕԁv̐ݒ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_WritOpeMode(&g_SlvRef, 0x64);
		if (ret != 0) {
			printf("hic400_WritOpeMode failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_OPE_MODE))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 2) // X, Ys
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritOpeMode BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case CIR_SEQ_START:	// X^[g
		g_SlvRef.axis = g_Ax_t[0] | g_Ax_t[1];
		ret = hic400_CnstStartFH(&g_SlvRef);
		if (ret != 0) {
			printf("hic400_CnstStartFH failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == CNST_START_FH))
		{
			subSeq = 0;
			apiBusyCnt = 0;
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_CnstStartFH BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	}
	return;
}

// Jog
void motion_Jog()
{
	uint32_t ret;

	switch (subSeq)
	{
	case JOG_SEQ_MODE:	// 샂[hu+Av̐ݒ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_WritOpeMode(&g_SlvRef, 0x00);
		if (ret != 0) {
			printf("hic400_WritOpeMode failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			ax_num = 0;
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_OPE_MODE))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 4) // Ss
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritOpeMode BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case JOG_SEQ_START:		// SΏ
		g_SlvRef.axis = g_Ax_t[4];
		ret = hic400_AccStart(&g_SlvRef);
		if (ret != 0) {
			printf("hic400_AccStart failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == ACC_START))
		{
			subSeq = 0;
			apiBusyCnt = 0; 
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_AccStart BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	}
	return;
}

// _A
void motion_Home()
{
	uint32_t ret;

	switch (subSeq)
	{
	case HOME_SEQ_ORG_MODE:	// _A[h0(OLS ONŒ~)̐ݒ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_SetOrgMode(&g_SlvRef, 0x00);
		if (ret != 0) {
			printf("hic400_SetOrgMode failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			ax_num = 0;
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == SET_ORG_MODE))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 4) // Ss
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_SetOrgMode BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case HOME_SEQ_MODE:	// 샂[hu_A[hvɂ
		g_SlvRef.axis = g_Ax_t[ax_num];
		ret = hic400_WritOpeMode(&g_SlvRef, 0x10);
		if (ret != 0) {
			printf("hic400_WritOpeMode failed. %s Error = 0x%x\n", g_AxName_t[ax_num], ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			ax_num = 0;
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == WRIT_OPE_MODE))
		{
			apiBusyCnt = 0;
			ax_num++; // ̎
			if (ax_num == 4) // Ss
			{
				subSeq++; // ̐ݒ
				ax_num = 0;
			}
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_WritOpeMode BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	case HOME_SEQ_START:	// SΏ
		g_SlvRef.axis = g_Ax_t[4];
		ret = hic400_AccStart(&g_SlvRef);
		if (ret != 0) {
			printf("hic400_AccStart failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == ACC_START))
		{
			subSeq = 0;
			apiBusyCnt = 0;
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_AccStart BusyJEgI[o[\n");
				setError();
				return;
			}
		}
		break;
	}
	return;
}

// ~
void motion_Stop()
{
	uint32_t ret;

	if (motionSeq == MOTION_SEQ_STOPPING) {	// P
		g_SlvRef.axis = g_Ax_t[4]; // SΏ
		ret = hic400_DecStop(&g_SlvRef); // ~
		if (ret != 0) {
			printf("hic400_DecStop failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == DEC_STOP))
		{
			subSeq = 0;
			apiBusyCnt = 0;
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_DecStop BusyJEgI[o[\n");
				setError();
				return;
			}
		}
	}
	else {	// ~ʕ
		g_SlvRef.axis = g_Ax_t[4]; // SΏ
		ret = hic400_wCmdW(&g_SlvRef, 0x49); // ~
		if (ret != 0) {
			printf("hic400_wCmdW failed. Error = 0x%x\n", ret);
			motionSeq = MOTION_SEQ_DONE;	// APIG[Ȃ瓮슮ɂĎ̃R}ht҂
			ClrCommand();
			return;
		}
		// API Xe[g`FbN
		if ((g_SlvRef.status == API_STA_DONE) && (g_SlvRef.currentApi == W_CMD_W))
		{
			subSeq = 0;
			apiBusyCnt = 0;
			ClrCommand();
		}
		else if (g_SlvRef.status == API_STA_BUSY) // Busy
		{
			apiBusyCnt++; // BusyJEg
			if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
				printf("hic400_wCmdW BusyJEgI[o[\n");
				setError();
				return;
			}
		}
	}
	return;
}

// I
void motion_Quit()
{
	uint32_t ret;
	uint16_t cmd = 0x10; /* SVOFF */

	// SΏ
	g_SlvRef.axis = g_Ax_t[4];
	ret = hic400_wCmdW(&g_SlvRef, cmd);
	if (ret != 0) {
		printf("hic400_wCmdW failed.\n");
		quit_f = TRUE;	// ItOL
	}
	// API Xe[g`FbN
	if (g_SlvRef.status == API_STA_DONE)
	{
		apiBusyCnt = 0;
		quit_f = TRUE;	// ItOL
	}
	else if (g_SlvRef.status == API_STA_BUSY) // Busy
	{
		apiBusyCnt++; // BusyJEg
		if (apiBusyCnt > BUSY_MAX_COUNT) { // JEgI[o[ʒm
			printf("hic400_wCmdW BusyJEgI[o[\n");
			quit_f = TRUE;	// ItOL
		}
	}
	return;
}

/*****************************************************************************
*
* DESCRIPTION:		[VXbh FTCNbNœ
*
\*****************************************************************************/
void	motion_thread(void* ptr)
{
	uint32_t	ret;	// ߂l
	uint16_t	woStatus; // Master API߂l

	// {XbhĂ邱Ƃo^
	gInit.hThread_m = GetRtThreadHandles(THIS_THREAD);

	// XbhJ^OAs͖
	Catalog(NULL_RTHANDLE, gInit.hThread_m, CLG_M_TH);

	// [vŃ[VJn
	while (1) {
		// RSI-ECAT-Master API : TCNbN҂               
		woStatus = EhWaitForCyclic(g_hAPI, WAIT_FOREVER);
		if (0 != woStatus) {
			printf("TCNbNf܂\n");
			break;  // دfꂽׁAI
		}

		// PDOǂݍ
		ret = hic400_rPdo(g_hAPI);
		if (ret != 0)
			printf("PDO ǂݍ݃G[ : %x\n", ret);

		readStatus();		// Xe[^Xǂݍ

		if (init_f == FALSE) // 
		{ 
			if(g_MotionSeq == MOTION_SEQ_NONE)
				motionSeq = MOTION_SEQ_INIT;
			else {
				switch (subSeq)
				{
				case INIT_SEQ_PORT:		// |[gݒ
					initPortC400();
					break;
				case INIT_SEQ_REG:		// WX^ݒ
					initRegC400();
					break;
				case INIT_SEQ_READY:	// ݒ
					readyToC400();
					break;
				case INIT_SEQ_ERROR:	// G[
					setError();
					break;
				}
			}
		}
		else
		{
			getCommand();	// ̓R}h擾
			switch (cmd)
			{
			case app_cmd_move:
				motionSeq = MOTION_SEQ_MOVING; // V[PX𓮍쒆ɂ
				motion_Move();
				break;
			case app_cmd_circle:
				motionSeq = MOTION_SEQ_CIRCLE; // V[PX𓮍쒆()ɂ
				motion_Circle();
				break;
			case app_cmd_jog:
				motionSeq = MOTION_SEQ_MOVING; // V[PX𓮍쒆ɂ
				motion_Jog();
				break;
			case app_cmd_home:
				motionSeq = MOTION_SEQ_MOVING; // V[PX𓮍쒆ɂ
				motion_Home();
				break;
			case app_cmd_stop:
				if (motionSeq == MOTION_SEQ_MOVING)
					motionSeq = MOTION_SEQ_STOPPING;	 // V[PX~ɂ
				else if(motionSeq == MOTION_SEQ_CIRCLE)
					motionSeq = MOTION_SEQ_STOPPING_CIR; // V[PX~()ɂ
				motion_Stop();
				break;
			case app_cmd_q:
				motionSeq = MOTION_SEQ_QUIT;
				motion_Quit();
				break;
			case app_cmd_e:
				motionSeq = MOTION_SEQ_EXIT;
				quit_f = TRUE;	// I
				break;
			}
			checkStatus();	// 슮Ď
		}

		// PDO
		ret = hic400_wPdo(g_hAPI);
		if (ret != 0)
			printf("PDO ݃G[ : %x\n", ret);

		UpdateStatus(motionSeq); // Xe[^XEV[PXԂ̍XV

		if (quit_f == TRUE) // I邩mF
			break;
	}
	// {Xbh̓~o^
	gInit.hThread_m = NULL_RTHANDLE;
}